#ifndef FZTAT_CTRL_H
#define FZTAT_CTRL_H

/*
  F-ZTAT ǗNX
  Satofumi KAMIMURA
  $Id$
*/

#include <string>
#include "serialDevice.h"
#include "sformatCtrl.h"


class FZTAT_Ctrl {
  enum {
    NotInitialized,
    BaudrateAdjusted,
    ProgramSended,
    Writed,
    Invalid,
    Timeout = 100,
    RetryMax = 3,
    LineMax = 80,
  };
  std::string error_message;
  SerialDevice* con;
  int debug_level;

public:
  typedef void (*progressView_t)(int, int);

private:
  progressView_t view_callback;

  const char* con_device;
  long write_baudrate;
  int mode;
  
  int connect(long baudrate);
  void disconnect(void);
  bool isLF(const char ch);
  bool fillSendBuffer(int* sended, char* buffer, const char* code, int left);
  long setDataBuffer(char* buffer, SFormat_Ctrl::srec_t* srec);
  FZTAT_Ctrl(void);
  
public:
  enum {
    WriteBaudrate = 115200,
  };

  FZTAT_Ctrl(const char* device, long writeBaudrate = WriteBaudrate);
  ~FZTAT_Ctrl(void);
  const char* what(void);
  bool adjustBaudrate(void);
  bool sendWriteProgram(char* code, int size);
  bool writeRom(char* code, int size, long baudrate);
  void setProgressCallback(progressView_t func);
};

#endif /*! FZTAT_CTRL_H */
